clear
path(path,'.\framelet_lib\v2.02');

% %=============================================
% %The following reproduce the results of Barbara listed in the Table 4.1.
% img=double(imread('barbara.jpg'));
% ker=fspecial('Gaussian',21,1);
% blur=@(f,k)imfilter(f,k,'circular');
% sigma=5;
% tol=1e-4;
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='F'; %FFT-based preconditioner
% mu=0.4;
% lambda=0.1;
% maxit=100;
% %=============================================

% %=============================================
% %The following reproduce the results of camera listed in the Table 4.1.
% rand('seed',3000);
% randn('seed',3000);
% img=double(imread('camera.png'));
% ker=fspecial('average',9);
% tol=1e-3;
% sigma=3;
% blur=@(f,k)imfilter(f,k,'circular');
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='F'; %FFT-based preconditioner
% mu=0.05;
% lambda=0.01;
% frame=1;
% Level=4;
% wLevel=1/sqrt(2);
% maxit=100;
% %=============================================

% %=============================================
% %The following reproduce the results of camera listed in the Table 4.1.
% rand('seed',3000);
% randn('seed',3000);
% img=double(imread('camera.png'));
% ker=fspecial('average',9);
% tol=1e-3;
% sigma=3;
% blur=@(f,k)imfilter(f,k,'circular');
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='F'; %FFT-based preconditioner
% mu=0.05;
% lambda=0.01;
% frame=1;
% Level=4;
% wLevel=1/sqrt(2);
% maxit=100;
% %=============================================

%=============================================
%The following reproduce the results of camera listed in the Table 4.1.
rand('seed',3000);
randn('seed',3000);
%img=double(imread('lena256.png'));
img=double(imread('goldhill256.png'));
ker=fspecial('average',9);
tol=1e-3;
sigma=3;
blur=@(f,k)imfilter(f,k,'circular');
og=blur(img,ker);
g=og+sigma*randn(size(img));
ForC='F'; %FFT-based preconditioner
mu=0.1;
lambda=0.05;
frame=1;
Level=4;
wLevel=1/2;
maxit=100;
%=============================================

% %=============================================
% %The following reproduce the results of camera listed in the Table 4.1.
% rand('seed',3000);
% randn('seed',3000);
% %img=double(imread('lena256.png'));
% img=double(imread('boat256.png'));
% ker=fspecial('disk',4);
% tol=1e-3;
% sigma=3;
% blur=@(f,k)imfilter(f,k,'circular');
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='F'; %FFT-based preconditioner
% mu=0.1;
% lambda=0.05;
% frame=1;
% Level=4;
% wLevel=1/2;
% maxit=100;
% %=============================================

% %=============================================
% %The following reproduce the results of shape listed in the Table 4.1.
% img=double(imread('shape150.jpg'));
% ker=fspecial('Gaussian',21,2);
% blur=@(f,k)imfilter(f,k,'circular');
% sigma=10;
% tol=1e-4;
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='F'; %FFT-based preconditioner
% mu=5;
% lambda=0.1;
% maxit=100;
% %=============================================


% %=============================================
% load flower19h_out_1000 
% ker=fftshift(rh1);
% blur=@(f,k)imfilter(f,k,'circular');
% %blur=@(f,k)conv2(f,k,'same');
% colorg=double(imread('flower19.bmp'));
% %g=colorg(:,:,1);
% tol=1e-4
% ForC='F'; %FFT-based preconditioner
% mu=0.2;
% lambda=0.1;
% maxit=20;
% %=============================================
% u(:,:,1)=SplitBregDebP(colorg(:,:,1),ker,blur,tol,mu,lambda,ForC,maxit);
% 
% u(:,:,2)=SplitBregDebP(colorg(:,:,2),ker,blur,tol,mu,lambda,ForC,maxit);
% u(:,:,3)=SplitBregDebP(colorg(:,:,3),ker,blur,tol,mu,lambda,ForC,maxit);
tic
u=SplitBregDebP(g,ker,blur,mu,lambda,tol,frame,Level,wLevel,maxit,img);
toc
%u=SplitBregDebP(g,ker,blur,tol,mu,lambda,ForC,maxit,img);

figure,imshow(uint8(u));
%20*log10(255*sqrt(prod(size(img)))/norm(u-img,'fro'))
s = snr(u, img)
